From 85f4b1d5323666a0f812d027d39b8bb7d9eb5fdb Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 7/16] Add SavedNotifications tests


---

diff --git a/hubs/app.py b/hubs/app.py
index a9d1893..925f3a3 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -632,16 +632,19 @@ def notifications(user):
         return flask.jsonify(notifications)
 
     if flask.request.method == 'POST':
-        data = flask.request.json
+        data = json.loads(flask.request.data)
+        user = hubs.models.User.by_username(session, user)
+        if not user:
+            return flask.abort(400)
         try:
             markup = data['markup']
             link = data['link']
             icon = data['secondary_icon']
             dom_id = data['dom_id']
         except:
-            return str(flask.request.data)
+            return flask.abort(400)
         notification = hubs.models.SavedNotification(
-            username=user,
+            username=user.username,
             markup=markup,
             link=link,
             secondary_icon=icon,
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index 153374a..e7f4eba 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -45,6 +45,10 @@ class APPTest(unittest.TestCase):
             fullname = user.title()
             hubs.models.User.get_or_create(
                 hubs.app.session, username=user, fullname=fullname)
+            saved_notif = hubs.models.SavedNotification(
+                username=user, markup='foo', link='bar'
+            )
+            hubs.app.session.add(saved_notif)
 
         hubs.app.session.flush()
 
diff --git a/hubs/tests/test_api/test_notifications.py b/hubs/tests/test_api/test_notifications.py
new file mode 100644
index 0000000..ea8616f
--- /dev/null
+++ b/hubs/tests/test_api/test_notifications.py
@@ -0,0 +1,84 @@
+import json
+from urlparse import urlparse
+
+import hubs.tests
+import hubs.models
+from hubs.app import app
+
+
+class TestGetNotifications(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('ralph')
+
+    def test_get_notifications_invalid_name(self):
+        name = 'notarealfasuser'
+
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.get('/{}/notifications/'.format(name))
+        self.assertEqual(resp.status_code, 200)
+        data = json.loads(resp.data)
+        self.assertEqual(data, [])
+
+    def test_get_notifications_valid_name(self):
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.get('/{}/notifications/'.format(
+                self.user.username))
+
+        self.assertEqual(resp.status_code, 200)
+        data = json.loads(resp.data)
+        self.assertEqual(len(data), 1)
+
+        for saved in data:
+            self.assertEqual(saved['markup'], 'foo')
+            self.assertEqual(saved['link'], 'bar')
+
+
+class TestPostNotifications(hubs.tests.APPTest):
+    user = hubs.tests.FakeAuthorization('ralph')
+    valid_payload = {
+        'username': user.username,
+        'markup': 'foobar',
+        'link': 'baz',
+        'secondary_icon': 'http://placekitten.com/g/200/300',
+        'dom_id': 'reallyuniqueuid'
+    }
+
+    invalid_payload = {
+        'username': user.username,
+    }
+
+    def test_post_notification_invalid_user(self):
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post(
+                '/{}/notifications/'.format('notarealfasuser'),
+                data=json.dumps(self.valid_payload))
+        self.assertEqual(resp.status_code, 400)
+
+    def test_post_notification_invalid_payload(self):
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post(
+                '/{}/notifications/'.format(self.user.username),
+                data=json.dumps(self.invalid_payload))
+        self.assertEqual(resp.status_code, 400)
+
+    def test_post_notification_valid_payload(self):
+        with hubs.tests.auth_set(app, self.user):
+            resp = self.app.post(
+                '/{}/notifications/'.format(self.user.username),
+                data=json.dumps(self.valid_payload))
+
+        self.assertEqual(resp.status_code, 200)
+        data = json.loads(resp.data)
+        self.assertTrue(isinstance(data, dict))
+
+        notification = data['notification']
+        self.assertEqual(notification['markup'], 'foobar')
+        self.assertEqual(notification['link'], 'baz')
+
+        all_saved = hubs.models.SavedNotification.by_username(
+            hubs.app.session, self.user.username)
+        self.assertEqual(len(all_saved), 2)
+        all_saved = [s.__json__() for s in all_saved]
+        self.assertTrue(any(str(s['markup']) == self.valid_payload['markup']
+                            for s in all_saved))
+        self.assertTrue(any(str(s['link']) == self.valid_payload['link']
+                            for s in all_saved))

